window.onload = function() {
  var copyAttribute = function(n, e, p) { var v = e.getAttribute(p); if (v) n.setAttribute(p, v); };
  
  var form = document.getElementsByName("form")[0];
  
  if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
    form = null; // IE doesn't support ranges
  }
  
  if (form) {
    // for each input type=range element, insert an input type=number 
    // element before it, and reflect changes in both of them.
    for (var i = 0; i < form.elements.length; i++) {
      var element = form.elements[i];
      if (element.getAttribute("type") === "range") {
          var node = document.createElement("input");
	  node.setAttribute("type", "number");
	  copyAttribute(node, element, "value");
	  copyAttribute(node, element, "size");
	  copyAttribute(node, element, "min");
	  copyAttribute(node, element, "max");
	  copyAttribute(node, element, "step");

	  (function (node, element) {
	    node.oninput = function() { element.value = node.value };
	    element.onchange = function() { node.value = element.value };
	  })(node, element);
	  node.style.width = "100px";

    	  element.parentElement.insertBefore(node, element);
	  i++; // skip over inserted element
      }
    }
  }
  
  var format = document.getElementById("format");
  if (format) {
    // setup format change function to change field visibility
    format.onchange = function(e) {
      var value = +format.value;
      var vis = (value != 3) ? '' : 'none'; // h264 visibility
     
      document.getElementById("bitrate").style.display = vis;
      document.getElementById("gopsize").style.display = vis;
      document.getElementById("aspectratio").style.display = vis;
      document.getElementById("jpegq").style.display = (vis === '') ? 'none' : '';
    }
    format.onchange();
  }

  var StreamType = document.getElementById('StreamType');
  if (StreamType) {
    StreamType.onchange = function(e) {
      var value = StreamType.value;
      var visUDP = (value === 'UDP') ? '' : 'none';
      var visSMTP = (value === 'SMTP') ? '' : 'none';
      var visRTMP = (value === 'RTMP') ? '' : 'none';
      var visFTP = (value === 'FTP') ? '' : 'none';
      
      
      document.getElementById('UDPDest').style.display = visUDP;
      document.getElementById('UDPRetry').style.display = visUDP;
      document.getElementById('UDPSeq').style.display = visUDP;
      document.getElementById('UDPPort').style.display = visUDP;
      
      document.getElementById('MailServer').style.display = visSMTP;
      document.getElementById('SelfAddress').style.display = visSMTP;
      document.getElementById('MailUser').style.display = visSMTP;
      document.getElementById('MailPassword').style.display = visSMTP;
      document.getElementById('Address').style.display = visSMTP;
      document.getElementById('Subject').style.display = visSMTP;
      document.getElementById('MessageLine').style.display = visSMTP;
      
      document.getElementById('FTPServer').style.display = visFTP;
      document.getElementById('FTPUser').style.display = visFTP;
      document.getElementById('FTPPassword').style.display = visFTP;
      
      document.getElementById('RTMPURL').style.display = visRTMP;
      document.getElementById('RTMPStream').style.display = visRTMP;
      
      
    };
    StreamType.onchange();
  }
};
